﻿<?php
error_reporting(0);
/*
filename : download.php
version  : 1.1 (12.11.2014)
author   : Nicolas Baudet <www.baudet.me>
since    : 12.11.2014

Copyright (C) 2014 Nicolas Baudet

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

// Traduction des titres
$trad = array();
$trad["FR"] = array (
	"appellation" => "Appellation",
	"producteur" => "Producteur",
	"couleur" => "Couleur",
	"cepage" => "C&eacute;page",
	"esprit" => "Esprit",
	"terroir" => "Terroir",
	"culture" => "Mode de culture",
	"vinification" => "Vinification et &eacute;levage",
	"degustation" => "Commentaire de d&eacute;gustation",
	"mets" => "Accords mets/vin",
	"service" => "Service",
	"distinction" => "Distinction"
);
$trad["DE"] = array (
	"appellation" => "Appellation",
	"producteur" => "Produzent",
	"couleur" => "Farbe",
	"cepage" => "Traubensorte",
	"esprit" => "Spiritus",
	"terroir" => "Terroir",
	"culture" => "Kultivierungsverfahren",
	"vinification" => "Weinbereitung und Weinausbau",
	"degustation" => "Verkostungsnotizen",
	"mets" => "Passende Speise",
	"service" => "Bedienung",
	"distinction" => "Auszeichnung/en"
);

// Récupération des infos passées en POST
$data = $_POST;
//var_dump($data);
$isPDF = $_POST['generationMethod'] == 'pdf' ? true : false;

if($isPDF)
	$filename = $_POST['nom'].'.pdf';
else
	$filename = $_POST['nom'].'.txt';
$langue = $_POST['langue'];

// Variables en fonction de la langue
if($langue == "FR")
	$tab = $trad["FR"];
elseif ($langue == "DE")
	$tab = $trad["DE"];
else
	die("Oups, une erreur s'est produite.");

// Création du PDF ou du fichier
if($isPDF) {
	include('mpdf/mpdf.php');
	$mpdf = new mPDF();
	$mpdf->WriteHTML($stylesheet, 1);
	$st = makePDF($tab, $data);
	//$st = utf8_encode($st);
	//var_dump($st);
	$mpdf->SetFooter('www.vino-online.ch - +4124 467 07 77 - info@vino-online.ch');
	$mpdf->SetTitle("Fiche article");
	$mpdf->SetAuthor("VINO l'Emotion du Vin Sarl, Aigle");
	$mpdf->SetCreator("Nicolas Baudet - www.baudet.me");
	$mpdf->WriteHTML($st, 2);
	$mpdf->Output($filename, "D");
	exit;
}
else {
	// Renvoi des header pour la création de fichier
	header("Cache-Control: public");
	header("Content-Description: File Transfer");
	header("Content-Disposition: attachment; filename=$filename");
	echo(makeWB($tab, $data));
}

/**
 * Génère le string contenant les informations nécessaires à la génération
 * d'une fiche article pour le web.
 */
function makeWB($tab, $data){
	$str = "";
	
	$str .= "<div class=\"produit\">
<div class=\"nom_produit\" style=\"display: none;\">$data[nom_produit]</div>
<div class=\"domaine\" style=\"display: none;\">$data[domaine]</div>".PHP_EOL;

	$str .= "<div class=\"appellation\"><h3>$tab[appellation]</h3>
$data[appellation]</div><!--appellation-->
<div class=\"producteur\"><h3>$tab[producteur]</h3>
$data[producteur]</div><!--producteur-->
<div class=\"couleur\"><h3>$tab[couleur]</h3>
$data[couleur]</div><!--couleur-->
<div class=\"cepage\"><h3>$tab[cepage]</h3>
$data[cepage]</div><!--cepage-->
<div class=\"esprit\"><h3>$tab[esprit]</h3>
$data[esprit]</div><!--esprit-->
<div class=\"terroir\"><h3>$tab[terroir]</h3>
$data[terroir]</div><!--terroir-->
<div class=\"culture\"><h3>$tab[culture]</h3>
$data[culture]</div><!--culture-->
<div class=\"vinification\"><h3>$tab[vinification]</h3>
$data[vinification]</div><!--vinification-->
<div class=\"degustation\"><h3>$tab[degustation]</h3>
$data[degustation]</div><!--degustation-->
<div class=\"mets\"><h3>$tab[mets]</h3>
$data[mets]".PHP_EOL."</div><!--mets-->
<div class=\"service\"><h3>$tab[service]</h3>
$data[service]</div><!--service-->".PHP_EOL;

	if($data['distinction'] != null){
		$str .= "<div class=\"distinction\"><h3>$tab[distinction]</h3>
$data[distinction]</div><!--distinction-->".PHP_EOL;

		$str .= "</div><!--produit-->";
	}
	return $str;
}

/**
 * Génère le string contenant les informations nécessaires à la génération
 * d'un PDF.
 */
function makePDF($tab, $data){
	//$str = "";
	
	$str = '<html>
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
</head>
<body>';

	$str .= "<img src=\"assets/header.png\" />
<h2 class=\"nom_produit\">$data[nom_produit]</h2>
<div class=\"domaine\">$data[domaine]</div>";
	
	$str .= getRow($tab[appellation], $data[appellation]);
	$str .= getRow($tab[producteur], $data[producteur]);
	$str .= getRow($tab[couleur], $data[couleur]);
	$str .= getRow($tab[cepage], $data[cepage]);
	$str .= getRow($tab[esprit], $data[esprit]);
	$str .= getRow($tab[terroir], $data[terroir]);
	$str .= getRow($tab[culture], $data[culture]);
	$str .= getRow($tab[vinification], $data[vinification]);
	$str .= getRow($tab[degustation], $data[degustation], false);
	$str .= getRow($tab[mets], $data[mets], false);
	$str .= getRow($tab[service], $data[service]);
	$str .= getRow($tab[distinction], $data[distinction]);

	$str .= "</body></html>";
	return $str;
}

/**
 * Génère la ligne pour une caractéristique du vin. Est affiché par défaut
 * sur une ligne, mais peut être découpé sur deux, avec le 3ème paramètre.
 */
function getRow($title, $content, $oneLine = true) {
	if(isset($content) && $content != "") {
		if($oneLine)
			return "<div><strong>$title</strong> &mdash; $content</div>";
		else
			return "<div><h4>$title :</h4>$content<div>";
	}
	else
		return "";
}
?>